Package org.bukkit.persistence

# Interface PersistentDataContainer

public interface PersistentDataContainer
This interface represents a map like object, capable of storing custom tags in it.

## Method Summary

Modifier and Type
Method
Description
`<T, Z> Z`
`get(@NotNull NamespacedKey key, @NotNull PersistentDataType<T,Z> type)`
Returns the metadata value that is stored on the `PersistentDataHolder` instance.
`@NotNull PersistentDataAdapterContext`
`getAdapterContext()`
Returns the adapter context this tag container uses.
`@NotNull Set<NamespacedKey>`
`getKeys()`
Get a set of keys present on this `PersistentDataContainer` instance.
`<T, Z> Z`
`getOrDefault(@NotNull NamespacedKey key, @NotNull PersistentDataType<T,Z> type, Z defaultValue)`
Returns the metadata value that is stored on the `PersistentDataHolder` instance.
`<T, Z> boolean`
`has(@NotNull NamespacedKey key, @NotNull PersistentDataType<T,Z> type)`
Returns if the persistent metadata provider has metadata registered matching the provided parameters.
`boolean`
`isEmpty()`
Returns if the container instance is empty, therefore has no entries inside it.
`void`
`remove(@NotNull NamespacedKey key)`
Removes a custom key from the `PersistentDataHolder` instance.
`<T, Z> void`
`set(@NotNull NamespacedKey key, @NotNull PersistentDataType<T,Z> type, Z value)`
Stores a metadata value on the `PersistentDataHolder` instance.

## Method Details

### set

<T, Z> void set(@NotNull @NotNull NamespacedKey key, @NotNull @NotNull PersistentDataType<T,Z> type, @NotNull Z value)
Stores a metadata value on the `PersistentDataHolder` instance.

This API cannot be used to manipulate minecraft data, as the values will be stored using your namespace. This method will override any existing value the `PersistentDataHolder` may have stored under the provided key.

Type Parameters:
  `T` - the generic java type of the tag value
  `Z` - the generic type of the object to store
Parameters:
  `key` - the key this value will be stored under
  `type` - the type this tag uses
  `value` - the value stored in the tag
Throws:
  `NullPointerException` - if the key is null
  `NullPointerException` - if the type is null
  `NullPointerException` - if the value is null. Removing a tag should be done using `remove(NamespacedKey)`
  `IllegalArgumentException` - if no suitable adapter will be found for the `PersistentDataType.getPrimitiveType()`

### has

<T, Z> boolean has(@NotNull @NotNull NamespacedKey key, @NotNull @NotNull PersistentDataType<T,Z> type)
Returns if the persistent metadata provider has metadata registered matching the provided parameters.

This method will only return if the found value has the same primitive data type as the provided key.

Storing a value using a custom `PersistentDataType` implementation will not store the complex data type. Therefore storing a UUID (by storing a byte[]) will match has("key" , `PersistentDataType.BYTE_ARRAY`). Likewise a stored byte[] will always match your UUID `PersistentDataType` even if it is not 16 bytes long.

This method is only usable for custom object keys. Overwriting existing tags, like the the display name, will not work as the values are stored using your namespace.

Type Parameters:
  `T` - the generic type of the stored primitive
  `Z` - the generic type of the eventually created complex object
Parameters:
  `key` - the key the value is stored under
  `type` - the type which primitive storage type has to match the value
Returns:
  if a value
Throws:
  `NullPointerException` - if the key to look up is null
  `NullPointerException` - if the type to cast the found object to is null

### get

@Nullable <T, Z> Z get(@NotNull @NotNull NamespacedKey key, @NotNull @NotNull PersistentDataType<T,Z> type)
Returns the metadata value that is stored on the `PersistentDataHolder` instance.

Type Parameters:
  `T` - the generic type of the stored primitive
  `Z` - the generic type of the eventually created complex object
Parameters:
  `key` - the key to look up in the custom tag map
  `type` - the type the value must have and will be casted to
Returns:
  the value or `null` if no value was mapped under the given value
Throws:
  `NullPointerException` - if the key to look up is null
  `NullPointerException` - if the type to cast the found object to is null
  `IllegalArgumentException` - if the value exists under the given key, but cannot be access using the given type
  `IllegalArgumentException` - if no suitable adapter will be found for the `PersistentDataType.getPrimitiveType()`

### getOrDefault

@NotNull <T, Z> Z getOrDefault(@NotNull @NotNull NamespacedKey key, @NotNull @NotNull PersistentDataType<T,Z> type, @NotNull Z defaultValue)
Returns the metadata value that is stored on the `PersistentDataHolder` instance. If the value does not exist in the container, the default value provided is returned.

Type Parameters:
  `T` - the generic type of the stored primitive
  `Z` - the generic type of the eventually created complex object
Parameters:
  `key` - the key to look up in the custom tag map
  `type` - the type the value must have and will be casted to
  `defaultValue` - the default value to return if no value was found for the provided key
Returns:
  the value or the default value if no value was mapped under the given value
Throws:
  `NullPointerException` - if the key to look up is null
  `NullPointerException` - if the type to cast the found object to is null
  `IllegalArgumentException` - if the value exists under the given key, but cannot be access using the given type
  `IllegalArgumentException` - if no suitable adapter will be found for the `PersistentDataType.getPrimitiveType()`

### getKeys

@NotNull @NotNull Set<NamespacedKey> getKeys()
Get a set of keys present on this `PersistentDataContainer` instance. Any changes made to the returned set will not be reflected on the instance.

Returns:
  the key set

### remove

void remove(@NotNull @NotNull NamespacedKey key)
Removes a custom key from the `PersistentDataHolder` instance.

Parameters:
  `key` - the key
Throws:
  `NullPointerException` - if the provided key is null

### isEmpty

boolean isEmpty()
Returns if the container instance is empty, therefore has no entries inside it.

Returns:
  the boolean

### getAdapterContext

@NotNull @NotNull PersistentDataAdapterContext getAdapterContext()
Returns the adapter context this tag container uses.

Returns:
  the tag context